package cn.fw.morax.domain.db.eval;

import cn.fw.common.data.entity.BaseAuditableTimeEntity;
import cn.fw.common.data.mybatis.handler.LongListTypeHandler;
import cn.fw.morax.domain.enums.EvalRewardDistStatusEnum;
import cn.fw.morax.domain.enums.EvalTypeEnum;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 考评门店奖惩分配
 * </p>
 *
 * @author jiangchao
 * @since 2023-02-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName(autoResultMap = true)
public class EvalRewardDist extends BaseAuditableTimeEntity<EvalRewardDist, Long> {

    private static final long serialVersionUID = 1L;

    /**
     * 用户id
     */
    private Long userId;
    /**
     * 考评组id
     */
    private Long evalGroupId;
    /**
     * 考评排名组id
     */
    private Long evalGroupRankId;
    /**
     * 考评排名组阶段id
     */
    private Long evalGroupRankStageId;
    /**
     * 考评排名组名称
     */
    private String evalGroupRankName;

    /**
     * 考评排名组阶段名称
     */
    private String evalGroupRankStageName;

    /**
     * 生效时间
     */
    private LocalDate beginTime;

    /**
     * 结束时间
     */
    private LocalDate overTime;

    /**
     * 考评组id
     */
    @TableField(typeHandler = LongListTypeHandler.class)
    private List<Long> evalShopPoolIds;

    /**
     * 门店id
     */
    @TableField(typeHandler = LongListTypeHandler.class)
    private List<Long> shopIds;

    /**
     * 考评奖惩
     */
    private BigDecimal reward;

    /**
     * 状态
     */
    private EvalRewardDistStatusEnum status;

    /**
     * 集团id
     */
    private Long groupId;

    /**
     * 逻辑删除
     */
    @TableLogic
    private Boolean yn;


}
