package cn.fw.morax.domain.vo.eval;

import cn.fw.common.data.entity.BaseAuditableTimeEntity;
import cn.fw.common.data.mybatis.handler.LongListTypeHandler;
import cn.fw.morax.domain.enums.EvalRewardDistStatusEnum;
import cn.fw.morax.domain.enums.EvalTypeEnum;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.List;

/**
 * <p>
 * 考评门店奖惩分配
 * </p>
 *
 * @author jiangchao
 * @since 2023-02-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class EvalRewardDistVO {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    private Long id;
    /**
     * 用户id
     */
    private Long userId;
    /**
     * 考评组id
     */
    private Long evalGroupId;
    /**
     * 考评排名组id
     */
    private Long evalGroupRankId;
    /**
     * 考评排名组阶段id
     */
    private Long evalGroupRankStageId;
    /**
     * 考评排名组名称
     */
    private String evalGroupRankName;

    /**
     * 考评排名组阶段名称
     */
    private String evalGroupRankStageName;

    /**
     * 生效时间
     */
    private LocalDate beginTime;

    /**
     * 结束时间
     */
    private LocalDate overTime;

    /**
     * 考评组id
     */
    @TableField(typeHandler = LongListTypeHandler.class)
    private List<Long> evalShopPoolIds;

    /**
     * 门店id
     */
    @TableField(typeHandler = LongListTypeHandler.class)
    private List<Long> shopIds;

    /**
     * 考评奖惩
     */
    private BigDecimal reward;

    /**
     * 状态
     */
    private EvalRewardDistStatusEnum status;

    /**
     * 集团id
     */
    private Long groupId;

    /**
     * 审批单号
     */
    private String approvalNo;

    /**
     * 门店
     */
    private List<EvalShopPoolVO> shopPools;

    /**
     * 奖惩详情
     */
    private List<EvalRewardDistDetailVO> rewardDetails;


}
